(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class EndToEnd {
    constructor(opts) {
        this.keys = {
            publics: [],
            privates: []
        };
        this.userId = opts.userId;
        if (opts.openpgp)
            this.openpgp = opts.openpgp;
        if (opts.onSend)
            this.onSend = opts.onSend;
        if (opts.keys)
            this.keys = opts.keys;
    }
    addUser(user) {
        if (!user || !user.publicKeyArmored || !user.userId || !user.roomId)
            throw new Error('wrong params for adduser');
        this.keys.publics.push(user);
    }
    whisperToUser(message) {
        return __awaiter(this, void 0, void 0, function* () {
            const msg = yield this.composeMessage(message);
            yield this.onSend({
                encString: msg.encString,
                roomId: message.roomId,
                userId: message.userId,
                authorId: msg.authorId,
                whisper: true
            });
        });
    }
    sendToUsers(message) {
        return __awaiter(this, void 0, void 0, function* () {
            const msgs = yield this.composeMessagesForUsers(message);
            const key = this.keys.privates.find(f => f.roomId === message.roomId);
            for (const msg of msgs) {
                yield this.onSend({
                    encString: msg.encString,
                    roomId: message.roomId,
                    userId: message.userId,
                    authorId: key.userId
                });
            }
        });
    }
    composeMessage(message, openpgp) {
        return __awaiter(this, void 0, void 0, function* () {
            const key = this.keys.publics.find(f => f.userId === message.userId);
            if (!key)
                throw new Error(message.userId + " key's not found");
            const myKey = this.keys.privates.find(f => f.roomId === message.roomId);
            const mgs = { clearString: message.clearString, roomId: message.roomId };
            const encMsg = Object.assign({ openpgp }, mgs);
            const encrypted = yield this.encryptString(encMsg);
            const m = {
                encString: encrypted,
                roomId: message.roomId,
                authorId: myKey.userId
            };
            return m;
        });
    }
    composeMessagesForUsers(opts, openpgp) {
        return __awaiter(this, void 0, void 0, function* () {
            const users = this.keys.publics.filter(f => f.roomId === opts.roomId);
            const messages = [];
            for (const user of users) {
                const clearUserMessage = {
                    roomId: opts.roomId,
                    clearString: opts.clearString,
                    userId: user.userId
                };
                const encUserMessage = yield this.composeMessage(clearUserMessage, openpgp);
                messages.push(encUserMessage);
            }
            return messages;
        });
    }
    readMessage(message, openpgp) {
        return __awaiter(this, void 0, void 0, function* () {
            const roomKey = this.keys.privates.find(f => f.roomId === message.roomId);
            if (!roomKey)
                throw new Error("can't decrypt");
            const opts = {
                openpgp: openpgp || this.openpgp,
                encString: message.encString,
                privateKey: roomKey.privateKey
            };
            return yield this.decryptString(opts);
        });
    }
    decryptString(opts) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield EndToEnd.decryptString(this.openpgp || opts.openpgp, opts.privateKey, opts.encString);
        });
    }
    encryptString(opts) {
        return __awaiter(this, void 0, void 0, function* () {
            const key = this.keys.publics.find(f => f.userId === this.userId && f.roomId === opts.roomId);
            if (key) {
                const settings = {
                    publicKeyArmored: key.publicKeyArmored,
                    clearString: opts.clearString
                };
                return yield EndToEnd.encryptString(this.openpgp || opts.openpgp, settings);
            }
            else if (opts.publicKeyArmored) {
                const settings = {
                    publicKeyArmored: opts.publicKeyArmored,
                    clearString: opts.clearString
                };
                return yield EndToEnd.encryptString(this.openpgp || opts.openpgp, settings);
            }
            else {
                throw new Error('wrong params');
            }
        });
    }
    getKey(roomId) {
        const roomKey = this.keys.privates.find(f => f.roomId === roomId);
        if (roomKey)
            return roomKey;
        return null;
    }
    setKey(opts) {
        return __awaiter(this, void 0, void 0, function* () {
            const roomKey = this.keys.privates.find(f => f.roomId === opts.roomId);
            if (roomKey)
                return roomKey;
            const passphrase = Math.random()
                .toString(36)
                .substring(2, 15) +
                Math.random()
                    .toString(36)
                    .substring(2, 15);
            const keys = yield EndToEnd.regenKey(this.openpgp || opts.opengp, {
                userId: this.userId,
                passphrase: passphrase
            });
            const newRoomKey = {
                privateKeyArmored: keys.privateKeyArmored,
                publicKeyArmored: keys.publicKeyArmored,
                revocationCertificate: keys.revocationCertificate,
                privateKey: keys.privateKey,
                roomId: opts.roomId,
                userId: this.userId,
                passphrase: passphrase
            };
            this.keys.publics.push(newRoomKey);
            return newRoomKey;
        });
    }
    static regenKey(openpgp, opts) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!openpgp)
                throw new Error('no opengp provided');
            const passphrase = opts.passphrase ||
                Math.random()
                    .toString(36)
                    .substring(2, 15) +
                    Math.random()
                        .toString(36)
                        .substring(2, 15);
            const opgp = yield openpgp.generateKey({
                userIds: [{ name: opts.userId }],
                curve: 'ed25519',
                passphrase: passphrase
            });
            const privateKey = (yield openpgp.key.readArmored(opgp.privateKeyArmored)).keys[0];
            yield privateKey.decrypt(passphrase);
            const keys = {
                privateKeyArmored: opgp.privateKeyArmored,
                publicKeyArmored: opgp.publicKeyArmored,
                revocationCertificate: opgp.revocationCertificate,
                privateKey: privateKey
            };
            return keys;
        });
    }
    static encryptString(openpgp, opts) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!openpgp)
                throw new Error('no opengp provided');
            const encrypted = yield openpgp.encrypt({
                message: openpgp.message.fromText(opts.clearString),
                publicKeys: (yield openpgp.key.readArmored(opts.publicKeyArmored)).keys
            });
            return encrypted.data;
        });
    }
    static decryptString(openpgp, privateKey, encString) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!openpgp)
                throw new Error('no opengp provided');
            const { data: decrypted } = yield openpgp.decrypt({
                message: yield openpgp.message.readArmored(encString),
                privateKeys: [privateKey]
            });
            return decrypted;
        });
    }
}
exports.EndToEnd = EndToEnd;

},{}],2:[function(require,module,exports){
const imported = require('./index');

window['EndToEnd']=imported.EndToEnd
},{"./index":1}]},{},[2]);
